﻿using System;
using System.Collections.Generic;
using System.Text;

using EaWorkflowDesignerAddin.Ui;

namespace EaWorkflowDesignerAddin
{
    public class Main
    {
        private MainformPresenter _mainFormPresenter = new MainformPresenter();
        private bool _showFullMenus = false;

        //Called Before EA starts to check Add-In Exists
        public String EA_Connect(EA.Repository Repository)
        {
            //No special processing required.
            return "a string";
        }

        //Called when user Click Add-Ins Menu item from within EA.
        //Populates the Menu with our desired selections.
        public object EA_GetMenuItems(EA.Repository Repository, string Location, string MenuName)
        {
            EA.Package aPackage = Repository.GetTreeSelectedPackage();
            switch (MenuName)
            {
                case "":
                    return "-&Workflow Designer";
                case "-&Workflow Designer":
                    //string[] ar = { "&Workflow Designer", "", "About..." };
                    string[] ar = { "&Workflow Designer", "", "About..." };
                    return ar;
            }
            return "";
        }

        //Sets the state of the menu depending if there is an active project or not
        private bool IsProjectOpen(EA.Repository Repository)
        {
            try
            {
                EA.Collection c = Repository.Models;
                return true;
            }
            catch
            {
                return false;
            }
        }

        //Called once Menu has been opened to see what menu items are active.
        public void EA_GetMenuState(EA.Repository Repository, string Location, string MenuName, string ItemName, ref bool IsEnabled, ref bool IsChecked)
        {
            if (IsProjectOpen(Repository))
            {
                if (ItemName == "&Workflow Designer")
                    IsChecked = _showFullMenus;
                else if (ItemName == "Menu2")
                    IsEnabled = _showFullMenus;
            }
            else
            {
                // If no open project, disable all menu options
                IsEnabled = false;
                //  ... except About 
                if (ItemName == "About...") IsEnabled = true;
            }
        }

        //Called when user makes a selection in the menu.
        //This is your main exit point to the rest of your Add-in
        public void EA_MenuClick(EA.Repository repository, 
            string location, 
            string menuName, 
            string itemName)
        {
            switch (itemName)
            {
                case "&Workflow Designer":

                    //String writerString;
                    //String tagString;

                    //tagString = "";
                    //writerString = "";

                    //EA.Package aPackage;
                    //aPackage = repository.GetTreeSelectedPackage();

                    //foreach (EA.Package thePackage in aPackage.Packages)
                    //{
                    //    writerString = writerString + thePackage.Name.ToString() + "," + thePackage.ObjectType.ToString() + "\n";
                    //    //MessageBox.Show(writerString);
                    //    foreach (EA.Element theElements in thePackage.Elements)
                    //    {
                    //        foreach (EA.TaggedValue theTags in theElements.TaggedValues)
                    //        {
                    //            tagString = tagString + theTags.Name.ToString() + "," + theTags.Value.ToString() + ",";
                    //        }
                    //        writerString = writerString + theElements.Name.ToString() + "," + theElements.ObjectType.ToString() + "," + tagString + "\n";
                    //        tagString = "";
                    //    }
                    //}

                    //foreach (EA.Element theElements in aPackage.Elements)
                    //{
                    //    foreach (EA.TaggedValue theTags in theElements.TaggedValues)
                    //    {
                    //        tagString = tagString + theTags.Name.ToString() + "," + theTags.Value.ToString() + ",";
                    //    }
                    //    writerString = writerString + theElements.Name.ToString() + "," + theElements.ObjectType.ToString() + "," + tagString;
                    //    tagString = "";
                    //}

                    _mainFormPresenter.ShowView(repository);


                    ////// create a writer and open the file
                    ////TextWriter tw = new StreamWriter(aPackage.Name.ToString() + ".csv");

                    ////// write a line of text to the file
                    ////tw.WriteLine(writerString);

                    ////// close the stream
                    ////tw.Close();

                    break;
                case "&Menu2":



                    break;
                case "About...":
                    AboutPresenter.ShowView();
                    break;
            }
        }
        //public bool readLine(StreamReader sreader)
        //{
        //    bool answer;
        //    answer = false;

        //    try
        //    {
        //        filecontents = filecontents + "\n" + sreader.ReadLine();
        //    }
        //    catch
        //    {
        //        answer = true;
        //    }

        //    return answer;
        //}
    }
}
